hsmagick-0.5: FFI bindings for the GraphicsMagick library

Safe Haskell | None

Graphics.Transform.Magick.Types

# Documentation

data HImage Source

Constructors

HImage |

Fields

image :: ForeignPtr HImage_
otherInfo :: ImageNotLoaded

data ImageNotLoaded Source

Constructors

ImageNotLoaded |

Fields

imageInfo :: ForeignPtr HImageInfo
exceptionInfo :: ForeignPtr ExceptionInfo

data Rectangle Source

Constructors

Rectangle |

Fields

width :: Word
height :: Word
x :: Int
y :: Int

Instances

Show Rectangle |
Storable Rectangle |

data AffineMatrix Source

Constructors

AffineMatrix |

Fields

sx :: Double
rx :: Double
ry :: Double
sy :: Double
tx :: Double
ty :: Double

Instances

Storable AffineMatrix |

data PixelPacket a Source

Constructors

PixelPacket |

Fields

red :: a
green :: a
blue :: a
opacity :: a

Instances

Storable (PixelPacket Word8) |

data Level Source

Constructors

Level |

Fields

black :: Double
mid :: Double
white :: Double

data Modulation Source

Constructors

Modulation |

Fields

brightness :: Double
saturation :: Double
hue :: Double

data Negation Source

Constructors

AllPixels |
GrayscalePixels |

type PixelPacketByte = PixelPacket Word8 Source

data ChannelType Source

Constructors

UndefinedChannel |
RedChannel |
CyanChannel |
GreenChannel |
MagentaChannel |
BlueChannel |
YellowChannel |
OpacityChannel |
BlackChannel |
MatteChannel |

Instances

Enum ChannelType |

getImage :: HImage -> ForeignPtr HImage_Source

getImageInfo :: HImage -> ForeignPtr HImageInfo Source

getExceptionInfo :: HImage -> ForeignPtr ExceptionInfo Source

mkUnloadedImage :: ForeignPtr HImageInfo -> ForeignPtr ExceptionInfo -> ImageNotLoaded Source

data FilterTypes Source

Constructors

UndefinedFilter |
PointFilter |
BoxFilter |
TriangleFilter |
HermiteFilter |
HanningFilter |
HammingFilter |
BlackmanFilter |
GaussianFilter |
QuadraticFilter |
CubicFilter |
CatromFilter |
MitchellFilter |
LacrosFilter |
BesselFilter |
SincFilter |

Instances

Enum FilterTypes |
Storable FilterTypes |

data CompositeOp Source

Constructors

Undefined |
Over |
In |
Out |
Atop |
Xor |
Plus |
Minus |
Add |
Subtract |
Difference |
Multiply |
Bumpmap |
Copy |
CopyRed |
CopyGreen |
CopyBlue |
CopyOpacity |
Clear |
Dissolve |
Displace |
Modulate |
Threshold |
No |
Darken |
Lighten |
Hue |
Saturate |
Colorize |
Luminize |
Screen |
Overlay |
CopyCyan |
CopyMagenta |
CopyYellow |
CopyBlack |

Instances

Enum CompositeOp |
Storable CompositeOp |

data Contrast Source

Constructors

IncreaseContrast |
DecreaseContrast |

data ImageCharacteristics Source

Constructors

ImageC |

Fields

cmyk :: Bool
grayscale :: Bool
mONOCHROME :: Bool
opaque :: Bool
palette :: Bool

Instances

Storable ImageCharacteristics |

data ImageStatistics Source

Constructors

ImageS |

Fields

red_ :: ImageChannelStatistics
green_ :: ImageChannelStatistics
blue_ :: ImageChannelStatistics
opacity_ :: ImageChannelStatistics

Instances

Storable ImageStatistics |

data ImageChannelStatistics Source

Constructors

ImageCS |

Fields

maximum :: Double
minimum :: Double
mean :: Double
standard_deviation :: Double
variance :: Double

Instances

Storable ImageChannelStatistics |

data SegmentInfo Source

Constructors

SegmentInfo |

Fields

x1 :: Double
y1 :: Double
x2 :: Double
y2 :: Double

data ImageOrder Source

Constructors

LeftToRight |
TopToBottom |

Instances

Enum ImageOrder |

data StorageType Source

Constructors

CharPixel |
ShortPixel |
IntegerPixel |
LongPixel |
FloatPixel |
DoublePixel |

Instances

Enum StorageType |

class Storable b => StorablePixel a b | a -> b where Source

Methods

storageType :: a -> StorageType Source

marshalPixel :: a -> bSource

unmarshalPixel :: b -> aSource

Instances

StorablePixel Double CDouble |
StorablePixel Float CFloat |
StorablePixel Word8 CUChar |
StorablePixel Word16 CUShort |
StorablePixel Word32 CUInt |
StorablePixel Word64 CULong |

newtype PixMap Source

Constructors

PixMap [QuantumType] |

Instances

Show PixMap |

pixelSize :: PixMap -> Int Source

data QuantumType Source

Constructors

R |
G |
B |
A |
O |
T |
C |
Y |
M |
K |
I |
P |

Instances

Show QuantumType |

data QuantumType2 Source

Constructors

UndefinedQuantum |
IndexQuantum |
GrayQuantum |
IndexAlphaQuantum |
GrayAlphaQuantum |
RedQuantum |
CyanQuantum |
GreenQuantum |
YellowQuantum |
BlueQuantum |
MagentaQuantum |
AlphaQuantum |
BlackQuantum |
RGBQuantum |
RGBAQuantum |
CMYKQuantum |
CMYKAQuantum |
CIEYQuantum |
CIEXYZQuantum |

Instances

Enum QuantumType2 |

data ExceptionInfo Source

Constructors

ExceptionInfo |

Fields

severity :: ExceptionType
reason :: CString
description :: CString
error_number :: CInt
mODULE :: CString
function :: CString
line :: CULong
signature__ :: CULong

Instances

Storable ExceptionInfo |

type ExportPixelAreaOptions = Word32 Source

type ExportPixelAreaInfo = Word32 Source

type ImportPixelAreaOptions = Word32 Source

type ImportPixelAreaInfo = Word32 Source

type ImagePtr = Ptr Image Source

type Image = Word32 Source

data CharArray Source

Constructors

CharArray |

Instances

Storable CharArray |

type CompressionType = Word32 Source

type InterlaceType = Word32 Source

type EndianType = Word32 Source

type ResolutionType = Word32 Source

type ColorspaceType = Word32 Source

type ImageType = Word32 Source

type StreamHandler = Word32 Source

type PreviewType = Word32 Source

type ClassType = Word32 Source

type ChromaticityInfo = Word32 Source

type OrientationType = Word32 Source

type RenderingIntent = Word32 Source

type GravityType = Word32 Source

type DisposeType = Word32 Source

type ErrorInfo = Word32 Source

type TimerInfo = Word32 Source

type CacheInfoPtr = Word32 Source

type ImageAttributePtr = Word32 Source

type Ascii85InfoPtr = Word32 Source

type BlobInfoPtr = Word32 Source

type SemaphoreInfoPtr = Word32 Source

type ExceptionType = CUInt Source

data HImageInfo Source

Constructors

HImageInfo |

Fields

compression :: CompressionType
temporary :: CUInt
adjoin :: CUInt
antialias :: CUInt
subimage :: CULong
subrange :: CULong
depth :: CULong
size :: CString
tile :: CString
page :: CString
interlace :: InterlaceType
endian :: EndianType
units :: ResolutionType
quality :: CULong
sampling_factor :: CString
server_name :: CString
font :: CString
texture :: CString
density :: CString
pointsize :: CDouble
fuzz :: CDouble
pen :: PixelPacketByte
background_color :: PixelPacketByte
border_color :: PixelPacketByte
matte_color :: PixelPacketByte
dither :: CUInt
monochrome :: CUInt
progress :: CUInt
colorspace :: ColorspaceType
tYPE :: ImageType
group :: CLong
verbose :: CUInt
view :: CString
authenticate :: CString
client_data :: CString
file :: Ptr CFile
magick :: String
filename :: String
cache :: CString
definitions :: CString
attributes :: Ptr Image
ping :: CUInt
preview_type :: PreviewType
affirm :: CUInt
blob :: CString
lENGTH :: CSize
unique :: CString
zero :: CString
signature :: CULong

Instances

Storable HImageInfo |

data HImage_ Source

Constructors

HImage_ |

Fields

storage_class :: ClassType
colorspace_ :: ColorspaceType
compression_ :: CompressionType
dither_ :: CUInt
matte :: CUInt
columns :: CULong
rows :: CULong
colors :: CUInt
depth_ :: CUInt
colormap :: CIntPtr
background_color_ :: PixelPacketByte
border_color_ :: PixelPacketByte
matte_color_ :: PixelPacketByte
gamma :: CDouble
chromaticity :: ChromaticityInfo
orientation :: OrientationType
rendering_intent :: RenderingIntent
units_ :: ResolutionType
montage :: CString
directory :: CString
geometry :: CString
offset :: CLong
x_resolution :: CDouble
y_resolution :: CDouble
page_ :: Rectangle
tile_info :: Rectangle
blur :: CDouble
fuzz_ :: CDouble
fILTER :: FilterTypes
interlace_ :: InterlaceType
endian_ :: EndianType
gravity :: GravityType
compose :: CompositeOp
dispose :: DisposeType
scene :: CULong
delay :: CULong
iterations :: CULong
total_colors :: CULong
start_loop :: CLong
eRROR :: ErrorInfo
timer :: TimerInfo
client_data_ :: CIntPtr
filename_ :: String
magick_filename :: String
magick_ :: String
magick_rows :: CULong
exception :: ExceptionInfo
previous :: CIntPtr
next :: CIntPtr
profiles :: CIntPtr
is_monochrome :: CUInt
is_grayscale :: CUInt
taint :: CUInt
clip_mask :: CIntPtr
cache_ :: CacheInfoPtr
attributes_ :: ImageAttributePtr
ascii85 :: Ascii85InfoPtr
blob_ :: BlobInfoPtr
reference_count :: CLong
semaphore :: SemaphoreInfoPtr
logging :: CUInt
list :: CIntPtr
signature_ :: CULong

Instances

Storable HImage_ |